
#include <assert.h>
#include <stdio.h>

#include "ttterm.h"
#include "ttbuffer.h"
#include "ttutils.h"

#include "LLLParse.h"
#include "FSTParse.h"

#include "parselll.h"
#include "parsefst.h"
#include "lllpp.h"
#include "fsttrafos.h"
#include "lllutils.h"

int main(int argc, char **argv)
{
	TTbuf buf;
	TTterm spec;
	TTtype_list trafos;

	if (argc != 3) {
		fprintf(stderr, "Usage: %s <script.trafo> <spec.lll>\n", argv[0]);
		exit(0);
	}

	TTutils_init();
	LLLinit();
	FSTinit();

	buf = TTbuffer_create();
	TTbuffer_read_named(buf, argv[1]);
	trafos = FSTparse(buf);
	TTbuffer_destroy(buf);

/*
	trafos = TTunsandwich_rec(trafos);
*/

	buf = TTbuffer_create();
	TTbuffer_read_named(buf, argv[2]);
	spec = LLLparse(buf);
	TTbuffer_destroy(buf);

	spec = TTunsandwich_rec(spec);

	spec = FSTapply_trafos(argv[1], trafos, spec);
	/*LLLconsistencyCheck(spec);*/

	buf = TTbuffer_create();
	LLLpretty_with_header(buf, spec);
	TTbuffer_write(buf, stdout);
	TTbuffer_destroy(buf);

	return 0;
}
