
#include <assert.h>
#include <stdio.h>
#include "cmdargs.h"

struct optstruct gv_opts;
extern int optind;

static void usage(const char *program_name)
{
	fprintf(stderr, "Usage: %s [options] <file>\n", program_name);
	fprintf(stderr, "Options:\n");
	fprintf(stderr,
		"  -f <format>   Input Format: bnf, lll, trafo, sdf\n");
}

extern int getopt(int, char *const *, const char *);
extern char *optarg;

void getoptions(int argc, char *argv[])
{
	int c;
	int errflg = 0;
	strcpy(gv_opts.input_format, "bnf");

	while ((c = getopt(argc, argv, "hf:")) != EOF) {
		switch (c) {
		case 'f':
			strcpy(gv_opts.input_format, optarg);
			break;
		case 'h':
			usage(argv[0]);
			exit(0);
			break;
		case '?':
			errflg++;
		}
	}

	if (errflg || optind > argc) {
		usage(argv[0]);
		exit(2);
	}

	gv_opts.input_file = argv[optind++];
}
