
#include <assert.h>
#include <stdio.h>
#include <sys/types.h>

#include "ttterm.h"
#include "ttbuffer.h"
#include "ttutils.h"

#include "SDFParse.h"

#include "parsesdf.h"
#include "cmdargs.h"
#include "genlll.h"

int main(int argc, char **argv)
{
	TTbuf buf;
	TTterm pt;

	TTutils_init();
	SDFinit();

	getoptions(argc, argv);

	if (strcmp(gv_opts.input_format, "sdf") == 0) {
		buf = TTbuffer_create();
		TTbuffer_read_named(buf, gv_opts.input_file);
		pt = SDFparse(buf);
		pt = TTunsandwich_rec(pt);
		TTbuffer_destroy(buf);
		generate_lll(pt);
	} else {
		fprintf(stderr, "Unknown format: %s\n", gv_opts.input_format);
	}

	return 0;
}
