#include <stdio.h>
#include <assert.h>
#include <sys/types.h>
#include "ttterm.h"
#include "ttbuffer.h"
#include "ttutils.h"
#include "ttparse.h"
#include "SDFScan.h"
#include "SDFParse.h"

typedef TTterm(*fparse)(void);

static int init = 0;
static TTterm args[1000];


static TTterm TTparset_qgt_qgt(void);
static TTterm TTparset_qlt_qlt(void);
static TTterm TTparseSDF_combined_symbol_sepby_t_qpipe(void);
static TTterm TTparset_qpipe(void);
static TTterm TTparset_sorts(void);
static TTterm TTparseSDF_module_star(void);
static TTterm TTparset_definition(void);
static TTterm TTparseSDF_char_class_star(void);
static TTterm TTparset___qdivide_(void);
static TTterm TTparset_qmultiply(void);
static TTterm TTparset_qplus(void);
static TTterm TTparset_qquestion(void);
static TTterm TTparseSDF_attributes_opt(void);
static TTterm TTparset___qgt(void);
static TTterm TTparseSDF_symbol_star(void);
static TTterm TTparseSDF_production_sepby_t_qgt(void);
static TTterm TTparset_qgt(void);
static TTterm TTparseSDF_priority_sepby_t_qcomma(void);
static TTterm TTparseSDF_section_star(void);
static TTterm TTparseSDF_imports_section_star(void);
static TTterm TTparset_module(void);
static TTterm TTparset_lexical(void);
static TTterm TTparseSDF_module_name_star(void);
static TTterm TTparset_imports(void);
static TTterm TTparset_hiddens(void);
static TTterm TTparseSDF_grammar_section_star(void);
static TTterm TTparset_exports(void);
static TTterm TTparset_variables(void);
static TTterm TTparseSDF_production_star(void);
static TTterm TTparset_syntax(void);
static TTterm TTparseSDF_restriction_star(void);
static TTterm TTparset_restrictions(void);
static TTterm TTparseSDF_priorities_opt(void);
static TTterm TTparset_priorities(void);
static TTterm TTparset_context_free(void);
static TTterm TTparseSDF_repetition_opt(void);
static TTterm TTparset_qcbclose(void);
static TTterm TTparseSDF_attr_seplist_opt(void);
static TTterm TTparset_qcbopen(void);
static TTterm TTparset_qpclose(void);
static TTterm TTparset_qpopen(void);
static TTterm TTparseSDF_attribute_suffix_opt(void);
static TTterm TTparseSDF_attribute_sepby_t_qcomma(void);
static TTterm TTparset_qcomma(void);

TTterm
TTparseSDF_attr_seplist( void )
{
    fparse fs[1];

    fs[0] = TTparseSDF_attribute_sepby_t_qcomma;
    return TTparseSDF_CONJUNCTION(TTfunSDF_attr_seplist, fs);
}

TTterm
TTparseSDF_attribute( void )
{
    fparse fs[2];

    fs[0] = TTparseSDF_attribute_word;
    fs[1] = TTparseSDF_attribute_suffix_opt;
    return TTparseSDF_CONJUNCTION(TTfunSDF_attribute, fs);
}

TTterm
TTparseSDF_attribute_suffix( void )
{
    fparse fs[3];

    fs[0] = TTparset_qpopen;
    fs[1] = TTparseSDF_literal;
    fs[2] = TTparset_qpclose;
    return TTparseSDF_CONJUNCTION(TTfunSDF_attribute_suffix, fs);
}

TTterm
TTparseSDF_attribute_word( void )
{
    fparse fs[1];

    fs[0] = TTparseSDF_ident;
    return TTparseSDF_CONJUNCTION(TTfunSDF_attribute_word, fs);
}

TTterm
TTparseSDF_attributes( void )
{
    fparse fs[3];

    fs[0] = TTparset_qcbopen;
    fs[1] = TTparseSDF_attr_seplist_opt;
    fs[2] = TTparset_qcbclose;
    return TTparseSDF_CONJUNCTION(TTfunSDF_attributes, fs);
}

TTterm
TTparseSDF_basic_symbol( void )
{
    fparse fs[7];
    fs[0] = TTparseSDF_sort;
    fs[1] = TTparseSDF_terminal;
    fs[2] = TTparseSDF_char_class;
    fs[3] = TTparseSDF_symbol_group;
    fs[4] = TTparseSDF_symbol_sep_plus;
    fs[5] = TTparseSDF_symbol_sep_star;
    fs[6] = TTparseSDF_symbol_permutation;
    return TTparseSDF_DISJUNCTION(TTfunSDF_basic_symbol, 7, fs);
}

TTterm
TTparseSDF_combined_symbol( void )
{
    fparse fs[2];

    fs[0] = TTparseSDF_basic_symbol;
    fs[1] = TTparseSDF_repetition_opt;
    return TTparseSDF_CONJUNCTION(TTfunSDF_combined_symbol, fs);
}

TTterm
TTparseSDF_context_free_priorities( void )
{
    fparse fs[3];

    fs[0] = TTparset_context_free;
    fs[1] = TTparset_priorities;
    fs[2] = TTparseSDF_priorities_opt;
    return TTparseSDF_CONJUNCTION(TTfunSDF_context_free_priorities, fs);
}

TTterm
TTparseSDF_context_free_restrictions( void )
{
    fparse fs[3];

    fs[0] = TTparset_context_free;
    fs[1] = TTparset_restrictions;
    fs[2] = TTparseSDF_restriction_star;
    return TTparseSDF_CONJUNCTION(TTfunSDF_context_free_restrictions, fs);
}

TTterm
TTparseSDF_context_free_syntax( void )
{
    fparse fs[3];

    fs[0] = TTparset_context_free;
    fs[1] = TTparset_syntax;
    fs[2] = TTparseSDF_production_star;
    return TTparseSDF_CONJUNCTION(TTfunSDF_context_free_syntax, fs);
}

TTterm
TTparseSDF_context_free_variables( void )
{
    fparse fs[2];

    fs[0] = TTparset_variables;
    fs[1] = TTparseSDF_production_star;
    return TTparseSDF_CONJUNCTION(TTfunSDF_context_free_variables, fs);
}

TTterm
TTparseSDF_exports_section( void )
{
    fparse fs[2];

    fs[0] = TTparset_exports;
    fs[1] = TTparseSDF_grammar_section_star;
    return TTparseSDF_CONJUNCTION(TTfunSDF_exports_section, fs);
}

TTterm
TTparseSDF_grammar_section( void )
{
    fparse fs[8];
    fs[0] = TTparseSDF_lexical_syntax;
    fs[1] = TTparseSDF_lexical_variables;
    fs[2] = TTparseSDF_lexical_restrictions;
    fs[3] = TTparseSDF_context_free_syntax;
    fs[4] = TTparseSDF_context_free_variables;
    fs[5] = TTparseSDF_context_free_restrictions;
    fs[6] = TTparseSDF_context_free_priorities;
    fs[7] = TTparseSDF_sorts_section;
    return TTparseSDF_DISJUNCTION(TTfunSDF_grammar_section, 8, fs);
}

TTterm
TTparseSDF_hiddens_section( void )
{
    fparse fs[2];

    fs[0] = TTparset_hiddens;
    fs[1] = TTparseSDF_grammar_section_star;
    return TTparseSDF_CONJUNCTION(TTfunSDF_hiddens_section, fs);
}

TTterm
TTparseSDF_imports_section( void )
{
    fparse fs[2];

    fs[0] = TTparset_imports;
    fs[1] = TTparseSDF_module_name_star;
    return TTparseSDF_CONJUNCTION(TTfunSDF_imports_section, fs);
}

TTterm
TTparseSDF_lexical_restrictions( void )
{
    fparse fs[3];

    fs[0] = TTparset_lexical;
    fs[1] = TTparset_restrictions;
    fs[2] = TTparseSDF_restriction_star;
    return TTparseSDF_CONJUNCTION(TTfunSDF_lexical_restrictions, fs);
}

TTterm
TTparseSDF_lexical_syntax( void )
{
    fparse fs[3];

    fs[0] = TTparset_lexical;
    fs[1] = TTparset_syntax;
    fs[2] = TTparseSDF_production_star;
    return TTparseSDF_CONJUNCTION(TTfunSDF_lexical_syntax, fs);
}

TTterm
TTparseSDF_lexical_variables( void )
{
    fparse fs[3];

    fs[0] = TTparset_lexical;
    fs[1] = TTparset_variables;
    fs[2] = TTparseSDF_production_star;
    return TTparseSDF_CONJUNCTION(TTfunSDF_lexical_variables, fs);
}

TTterm
TTparseSDF_module( void )
{
    fparse fs[4];

    fs[0] = TTparset_module;
    fs[1] = TTparseSDF_module_name;
    fs[2] = TTparseSDF_imports_section_star;
    fs[3] = TTparseSDF_section_star;
    return TTparseSDF_CONJUNCTION(TTfunSDF_module, fs);
}

TTterm
TTparseSDF_module_name( void )
{
    fparse fs[1];

    fs[0] = TTparseSDF_ident;
    return TTparseSDF_CONJUNCTION(TTfunSDF_module_name, fs);
}

TTterm
TTparseSDF_priorities( void )
{
    fparse fs[1];

    fs[0] = TTparseSDF_priority_sepby_t_qcomma;
    return TTparseSDF_CONJUNCTION(TTfunSDF_priorities, fs);
}

TTterm
TTparseSDF_priority( void )
{
    fparse fs[1];

    fs[0] = TTparseSDF_production_sepby_t_qgt;
    return TTparseSDF_CONJUNCTION(TTfunSDF_priority, fs);
}

TTterm
TTparseSDF_production( void )
{
    fparse fs[4];

    fs[0] = TTparseSDF_symbol_star;
    fs[1] = TTparset___qgt;
    fs[2] = TTparseSDF_symbol;
    fs[3] = TTparseSDF_attributes_opt;
    return TTparseSDF_CONJUNCTION(TTfunSDF_production, fs);
}

TTterm
TTparseSDF_repetition( void )
{
    fparse fs[3];
    fs[0] = TTparset_qquestion;
    fs[1] = TTparset_qplus;
    fs[2] = TTparset_qmultiply;
    return TTparseSDF_DISJUNCTION(TTfunSDF_repetition, 3, fs);
}

TTterm
TTparseSDF_restriction( void )
{
    fparse fs[3];

    fs[0] = TTparseSDF_symbol_star;
    fs[1] = TTparset___qdivide_;
    fs[2] = TTparseSDF_char_class_star;
    return TTparseSDF_CONJUNCTION(TTfunSDF_restriction, fs);
}

TTterm
TTparseSDF_sdf( void )
{
    fparse fs[2];

    fs[0] = TTparset_definition;
    fs[1] = TTparseSDF_module_star;
    return TTparseSDF_CONJUNCTION(TTfunSDF_sdf, fs);
}

TTterm
TTparseSDF_section( void )
{
    fparse fs[2];
    fs[0] = TTparseSDF_exports_section;
    fs[1] = TTparseSDF_hiddens_section;
    return TTparseSDF_DISJUNCTION(TTfunSDF_section, 2, fs);
}

TTterm
TTparseSDF_sort( void )
{
    fparse fs[1];

    fs[0] = TTparseSDF_ident;
    return TTparseSDF_CONJUNCTION(TTfunSDF_sort, fs);
}

TTterm
TTparseSDF_sorts_section( void )
{
    fparse fs[2];

    fs[0] = TTparset_sorts;
    fs[1] = TTparseSDF_symbol_star;
    return TTparseSDF_CONJUNCTION(TTfunSDF_sorts_section, fs);
}

TTterm
TTparseSDF_symbol( void )
{
    fparse fs[1];

    fs[0] = TTparseSDF_combined_symbol_sepby_t_qpipe;
    return TTparseSDF_CONJUNCTION(TTfunSDF_symbol, fs);
}

TTterm
TTparseSDF_symbol_group( void )
{
    fparse fs[3];

    fs[0] = TTparset_qpopen;
    fs[1] = TTparseSDF_symbol_star;
    fs[2] = TTparset_qpclose;
    return TTparseSDF_CONJUNCTION(TTfunSDF_symbol_group, fs);
}

TTterm
TTparseSDF_symbol_permutation( void )
{
    fparse fs[3];

    fs[0] = TTparset_qlt_qlt;
    fs[1] = TTparseSDF_symbol_star;
    fs[2] = TTparset_qgt_qgt;
    return TTparseSDF_CONJUNCTION(TTfunSDF_symbol_permutation, fs);
}

TTterm
TTparseSDF_symbol_sep_plus( void )
{
    fparse fs[5];

    fs[0] = TTparset_qcbopen;
    fs[1] = TTparseSDF_symbol;
    fs[2] = TTparseSDF_symbol;
    fs[3] = TTparset_qcbclose;
    fs[4] = TTparset_qplus;
    return TTparseSDF_CONJUNCTION(TTfunSDF_symbol_sep_plus, fs);
}

TTterm
TTparseSDF_symbol_sep_star( void )
{
    fparse fs[5];

    fs[0] = TTparset_qcbopen;
    fs[1] = TTparseSDF_symbol;
    fs[2] = TTparseSDF_symbol;
    fs[3] = TTparset_qcbclose;
    fs[4] = TTparset_qmultiply;
    return TTparseSDF_CONJUNCTION(TTfunSDF_symbol_sep_star, fs);
}

TTterm
TTparseSDF_terminal( void )
{
    fparse fs[1];

    fs[0] = TTparseSDF_literal;
    return TTparseSDF_CONJUNCTION(TTfunSDF_terminal, fs);
}

static TTterm
TTparset_qgt_qgt( void )
{
    return TTparseSDF_KEYWORD(">>");
}

static TTterm
TTparset_qlt_qlt( void )
{
    return TTparseSDF_KEYWORD("<<");
}

static TTterm
TTparseSDF_combined_symbol_sepby_t_qpipe( void )
{
    return TTparse_alternation_plus(TTparseSDF_combined_symbol, TTparset_qpipe);
}

static TTterm
TTparset_qpipe( void )
{
    return TTparseSDF_KEYWORD("|");
}

static TTterm
TTparset_sorts( void )
{
    return TTparseSDF_KEYWORD("sorts");
}

static TTterm
TTparseSDF_module_star( void )
{
    return TTparse_star(TTparseSDF_module);
}

static TTterm
TTparset_definition( void )
{
    return TTparseSDF_KEYWORD("definition");
}

static TTterm
TTparseSDF_char_class_star( void )
{
    return TTparse_star(TTparseSDF_char_class);
}

static TTterm
TTparset___qdivide_( void )
{
    return TTparseSDF_KEYWORD("-/-");
}

static TTterm
TTparset_qmultiply( void )
{
    return TTparseSDF_KEYWORD("*");
}

static TTterm
TTparset_qplus( void )
{
    return TTparseSDF_KEYWORD("+");
}

static TTterm
TTparset_qquestion( void )
{
    return TTparseSDF_KEYWORD("?");
}

static TTterm
TTparseSDF_attributes_opt( void )
{
    return TTparse_optional(TTparseSDF_attributes);
}

static TTterm
TTparset___qgt( void )
{
    return TTparseSDF_KEYWORD("->");
}

static TTterm
TTparseSDF_symbol_star( void )
{
    return TTparse_star(TTparseSDF_symbol);
}

static TTterm
TTparseSDF_production_sepby_t_qgt( void )
{
    return TTparse_alternation_plus(TTparseSDF_production, TTparset_qgt);
}

static TTterm
TTparset_qgt( void )
{
    return TTparseSDF_KEYWORD(">");
}

static TTterm
TTparseSDF_priority_sepby_t_qcomma( void )
{
    return TTparse_alternation_plus(TTparseSDF_priority, TTparset_qcomma);
}

static TTterm
TTparseSDF_section_star( void )
{
    return TTparse_star(TTparseSDF_section);
}

static TTterm
TTparseSDF_imports_section_star( void )
{
    return TTparse_star(TTparseSDF_imports_section);
}

static TTterm
TTparset_module( void )
{
    return TTparseSDF_KEYWORD("module");
}

static TTterm
TTparset_lexical( void )
{
    return TTparseSDF_KEYWORD("lexical");
}

static TTterm
TTparseSDF_module_name_star( void )
{
    return TTparse_star(TTparseSDF_module_name);
}

static TTterm
TTparset_imports( void )
{
    return TTparseSDF_KEYWORD("imports");
}

static TTterm
TTparset_hiddens( void )
{
    return TTparseSDF_KEYWORD("hiddens");
}

static TTterm
TTparseSDF_grammar_section_star( void )
{
    return TTparse_star(TTparseSDF_grammar_section);
}

static TTterm
TTparset_exports( void )
{
    return TTparseSDF_KEYWORD("exports");
}

static TTterm
TTparset_variables( void )
{
    return TTparseSDF_KEYWORD("variables");
}

static TTterm
TTparseSDF_production_star( void )
{
    return TTparse_star(TTparseSDF_production);
}

static TTterm
TTparset_syntax( void )
{
    return TTparseSDF_KEYWORD("syntax");
}

static TTterm
TTparseSDF_restriction_star( void )
{
    return TTparse_star(TTparseSDF_restriction);
}

static TTterm
TTparset_restrictions( void )
{
    return TTparseSDF_KEYWORD("restrictions");
}

static TTterm
TTparseSDF_priorities_opt( void )
{
    return TTparse_optional(TTparseSDF_priorities);
}

static TTterm
TTparset_priorities( void )
{
    return TTparseSDF_KEYWORD("priorities");
}

static TTterm
TTparset_context_free( void )
{
    return TTparseSDF_KEYWORD("context-free");
}

static TTterm
TTparseSDF_repetition_opt( void )
{
    return TTparse_optional(TTparseSDF_repetition);
}

static TTterm
TTparset_qcbclose( void )
{
    return TTparseSDF_KEYWORD("}");
}

static TTterm
TTparseSDF_attr_seplist_opt( void )
{
    return TTparse_optional(TTparseSDF_attr_seplist);
}

static TTterm
TTparset_qcbopen( void )
{
    return TTparseSDF_KEYWORD("{");
}

static TTterm
TTparset_qpclose( void )
{
    return TTparseSDF_KEYWORD(")");
}

static TTterm
TTparset_qpopen( void )
{
    return TTparseSDF_KEYWORD("(");
}

static TTterm
TTparseSDF_attribute_suffix_opt( void )
{
    return TTparse_optional(TTparseSDF_attribute_suffix);
}

static TTterm
TTparseSDF_attribute_sepby_t_qcomma( void )
{
    return TTparse_alternation_plus(TTparseSDF_attribute, TTparset_qcomma);
}

static TTterm
TTparset_qcomma( void )
{
    return TTparseSDF_KEYWORD(",");
}


BOOL
SDFisKeyword(const char * name)
{
    if (strcmp(name, "exports") < 0) {
    if (strcmp(name, "->") < 0) {
    if (strcmp(name, "+") < 0) {
    if (strcmp(name, ")") < 0) {
        return strcmp(name, "(") == 0;
    } else {
    if (strcmp(name, "*") < 0) {
        return strcmp(name, ")") == 0;
    } else {
        return strcmp(name, "*") == 0;
    }
        return FALSE;
    }
        return FALSE;
    } else {
    if (strcmp(name, ",") < 0) {
        return strcmp(name, "+") == 0;
    } else {
    if (strcmp(name, "-/-") < 0) {
        return strcmp(name, ",") == 0;
    } else {
        return strcmp(name, "-/-") == 0;
    }
        return FALSE;
    }
        return FALSE;
    }
        return FALSE;
    } else {
    if (strcmp(name, ">>") < 0) {
    if (strcmp(name, "<<") < 0) {
        return strcmp(name, "->") == 0;
    } else {
    if (strcmp(name, ">") < 0) {
        return strcmp(name, "<<") == 0;
    } else {
        return strcmp(name, ">") == 0;
    }
        return FALSE;
    }
        return FALSE;
    } else {
    if (strcmp(name, "context-free") < 0) {
    if (strcmp(name, "?") < 0) {
        return strcmp(name, ">>") == 0;
    } else {
        return strcmp(name, "?") == 0;
    }
        return FALSE;
    } else {
    if (strcmp(name, "definition") < 0) {
        return strcmp(name, "context-free") == 0;
    } else {
        return strcmp(name, "definition") == 0;
    }
        return FALSE;
    }
        return FALSE;
    }
        return FALSE;
    }
        return FALSE;
    } else {
    if (strcmp(name, "restrictions") < 0) {
    if (strcmp(name, "lexical") < 0) {
    if (strcmp(name, "hiddens") < 0) {
        return strcmp(name, "exports") == 0;
    } else {
    if (strcmp(name, "imports") < 0) {
        return strcmp(name, "hiddens") == 0;
    } else {
        return strcmp(name, "imports") == 0;
    }
        return FALSE;
    }
        return FALSE;
    } else {
    if (strcmp(name, "module") < 0) {
        return strcmp(name, "lexical") == 0;
    } else {
    if (strcmp(name, "priorities") < 0) {
        return strcmp(name, "module") == 0;
    } else {
        return strcmp(name, "priorities") == 0;
    }
        return FALSE;
    }
        return FALSE;
    }
        return FALSE;
    } else {
    if (strcmp(name, "variables") < 0) {
    if (strcmp(name, "sorts") < 0) {
        return strcmp(name, "restrictions") == 0;
    } else {
    if (strcmp(name, "syntax") < 0) {
        return strcmp(name, "sorts") == 0;
    } else {
        return strcmp(name, "syntax") == 0;
    }
        return FALSE;
    }
        return FALSE;
    } else {
    if (strcmp(name, "|") < 0) {
    if (strcmp(name, "{") < 0) {
        return strcmp(name, "variables") == 0;
    } else {
        return strcmp(name, "{") == 0;
    }
        return FALSE;
    } else {
    if (strcmp(name, "}") < 0) {
        return strcmp(name, "|") == 0;
    } else {
        return strcmp(name, "}") == 0;
    }
        return FALSE;
    }
        return FALSE;
    }
        return FALSE;
    }
        return FALSE;
    }
        return FALSE;
}
void
SDFinit( void )
{
    if(init == 0)
    {
        TTutils_init();
        TTfunSDF_attr_seplist = TTbuild_fun("SDF_attr_seplist", 1);
        TTfunSDF_attribute = TTbuild_fun("SDF_attribute", 2);
        TTfunSDF_attribute_suffix = TTbuild_fun("SDF_attribute_suffix", 3);
        TTfunSDF_attribute_word = TTbuild_fun("SDF_attribute_word", 1);
        TTfunSDF_attributes = TTbuild_fun("SDF_attributes", 3);
        TTfunSDF_basic_symbol = TTbuild_fun("SDF_basic_symbol", 1);
        TTfunSDF_combined_symbol = TTbuild_fun("SDF_combined_symbol", 2);
        TTfunSDF_context_free_priorities = TTbuild_fun("SDF_context_free_priorities", 3);
        TTfunSDF_context_free_restrictions = TTbuild_fun("SDF_context_free_restrictions", 3);
        TTfunSDF_context_free_syntax = TTbuild_fun("SDF_context_free_syntax", 3);
        TTfunSDF_context_free_variables = TTbuild_fun("SDF_context_free_variables", 2);
        TTfunSDF_exports_section = TTbuild_fun("SDF_exports_section", 2);
        TTfunSDF_grammar_section = TTbuild_fun("SDF_grammar_section", 1);
        TTfunSDF_hiddens_section = TTbuild_fun("SDF_hiddens_section", 2);
        TTfunSDF_imports_section = TTbuild_fun("SDF_imports_section", 2);
        TTfunSDF_lexical_restrictions = TTbuild_fun("SDF_lexical_restrictions", 3);
        TTfunSDF_lexical_syntax = TTbuild_fun("SDF_lexical_syntax", 3);
        TTfunSDF_lexical_variables = TTbuild_fun("SDF_lexical_variables", 3);
        TTfunSDF_module = TTbuild_fun("SDF_module", 4);
        TTfunSDF_module_name = TTbuild_fun("SDF_module_name", 1);
        TTfunSDF_priorities = TTbuild_fun("SDF_priorities", 1);
        TTfunSDF_priority = TTbuild_fun("SDF_priority", 1);
        TTfunSDF_production = TTbuild_fun("SDF_production", 4);
        TTfunSDF_repetition = TTbuild_fun("SDF_repetition", 1);
        TTfunSDF_restriction = TTbuild_fun("SDF_restriction", 3);
        TTfunSDF_sdf = TTbuild_fun("SDF_sdf", 2);
        TTfunSDF_section = TTbuild_fun("SDF_section", 1);
        TTfunSDF_sort = TTbuild_fun("SDF_sort", 1);
        TTfunSDF_sorts_section = TTbuild_fun("SDF_sorts_section", 2);
        TTfunSDF_symbol = TTbuild_fun("SDF_symbol", 1);
        TTfunSDF_symbol_group = TTbuild_fun("SDF_symbol_group", 3);
        TTfunSDF_symbol_permutation = TTbuild_fun("SDF_symbol_permutation", 3);
        TTfunSDF_symbol_sep_plus = TTbuild_fun("SDF_symbol_sep_plus", 5);
        TTfunSDF_symbol_sep_star = TTbuild_fun("SDF_symbol_sep_star", 5);
        TTfunSDF_terminal = TTbuild_fun("SDF_terminal", 1);
        TTfunSDF_char_class = TTbuild_fun("SDF_char_class", 1);
        TTfunSDF_ident = TTbuild_fun("SDF_ident", 1);
        TTfunSDF_literal = TTbuild_fun("SDF_literal", 1);
    }
    init++;
}

static BOOL TTist_qgt_qgt(TTterm t);
static BOOL TTist_qlt_qlt(TTterm t);
static BOOL TTisSDF_combined_symbol_sepby_t_qpipe(TTterm t);
static BOOL TTist_qpipe(TTterm t);
static BOOL TTist_sorts(TTterm t);
static BOOL TTisSDF_module_star(TTterm t);
static BOOL TTist_definition(TTterm t);
static BOOL TTisSDF_char_class_star(TTterm t);
static BOOL TTist___qdivide_(TTterm t);
static BOOL TTist_qmultiply(TTterm t);
static BOOL TTist_qplus(TTterm t);
static BOOL TTist_qquestion(TTterm t);
static BOOL TTisSDF_attributes_opt(TTterm t);
static BOOL TTist___qgt(TTterm t);
static BOOL TTisSDF_symbol_star(TTterm t);
static BOOL TTisSDF_production_sepby_t_qgt(TTterm t);
static BOOL TTist_qgt(TTterm t);
static BOOL TTisSDF_priority_sepby_t_qcomma(TTterm t);
static BOOL TTisSDF_section_star(TTterm t);
static BOOL TTisSDF_imports_section_star(TTterm t);
static BOOL TTist_module(TTterm t);
static BOOL TTist_lexical(TTterm t);
static BOOL TTisSDF_module_name_star(TTterm t);
static BOOL TTist_imports(TTterm t);
static BOOL TTist_hiddens(TTterm t);
static BOOL TTisSDF_grammar_section_star(TTterm t);
static BOOL TTist_exports(TTterm t);
static BOOL TTist_variables(TTterm t);
static BOOL TTisSDF_production_star(TTterm t);
static BOOL TTist_syntax(TTterm t);
static BOOL TTisSDF_restriction_star(TTterm t);
static BOOL TTist_restrictions(TTterm t);
static BOOL TTisSDF_priorities_opt(TTterm t);
static BOOL TTist_priorities(TTterm t);
static BOOL TTist_context_free(TTterm t);
static BOOL TTisSDF_repetition_opt(TTterm t);
static BOOL TTist_qcbclose(TTterm t);
static BOOL TTisSDF_attr_seplist_opt(TTterm t);
static BOOL TTist_qcbopen(TTterm t);
static BOOL TTist_qpclose(TTterm t);
static BOOL TTist_qpopen(TTterm t);
static BOOL TTisSDF_attribute_suffix_opt(TTterm t);
static BOOL TTisSDF_attribute_sepby_t_qcomma(TTterm t);
static BOOL TTist_qcomma(TTterm t);

static BOOL
TTist_qgt_qgt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, ">>");
}

static BOOL
TTist_qlt_qlt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "<<");
}

static BOOL
TTisSDF_combined_symbol_sepby_t_qpipe(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_plus(t, TTisSDF_combined_symbol);
}

static BOOL
TTist_qpipe(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "|");
}

static BOOL
TTist_sorts(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "sorts");
}

static BOOL
TTisSDF_module_star(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_star(t, TTisSDF_module);
}

static BOOL
TTist_definition(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "definition");
}

static BOOL
TTisSDF_char_class_star(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_star(t, TTisSDF_char_class);
}

static BOOL
TTist___qdivide_(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "-/-");
}

static BOOL
TTist_qmultiply(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "*");
}

static BOOL
TTist_qplus(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "+");
}

static BOOL
TTist_qquestion(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "?");
}

static BOOL
TTisSDF_attributes_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTisSDF_attributes);
}

static BOOL
TTist___qgt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "->");
}

static BOOL
TTisSDF_symbol_star(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_star(t, TTisSDF_symbol);
}

static BOOL
TTisSDF_production_sepby_t_qgt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_plus(t, TTisSDF_production);
}

static BOOL
TTist_qgt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, ">");
}

static BOOL
TTisSDF_priority_sepby_t_qcomma(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_plus(t, TTisSDF_priority);
}

static BOOL
TTisSDF_section_star(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_star(t, TTisSDF_section);
}

static BOOL
TTisSDF_imports_section_star(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_star(t, TTisSDF_imports_section);
}

static BOOL
TTist_module(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "module");
}

static BOOL
TTist_lexical(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "lexical");
}

static BOOL
TTisSDF_module_name_star(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_star(t, TTisSDF_module_name);
}

static BOOL
TTist_imports(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "imports");
}

static BOOL
TTist_hiddens(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "hiddens");
}

static BOOL
TTisSDF_grammar_section_star(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_star(t, TTisSDF_grammar_section);
}

static BOOL
TTist_exports(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "exports");
}

static BOOL
TTist_variables(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "variables");
}

static BOOL
TTisSDF_production_star(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_star(t, TTisSDF_production);
}

static BOOL
TTist_syntax(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "syntax");
}

static BOOL
TTisSDF_restriction_star(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_star(t, TTisSDF_restriction);
}

static BOOL
TTist_restrictions(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "restrictions");
}

static BOOL
TTisSDF_priorities_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTisSDF_priorities);
}

static BOOL
TTist_priorities(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "priorities");
}

static BOOL
TTist_context_free(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "context-free");
}

static BOOL
TTisSDF_repetition_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTisSDF_repetition);
}

static BOOL
TTist_qcbclose(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "}");
}

static BOOL
TTisSDF_attr_seplist_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTisSDF_attr_seplist);
}

static BOOL
TTist_qcbopen(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "{");
}

static BOOL
TTist_qpclose(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, ")");
}

static BOOL
TTist_qpopen(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "(");
}

static BOOL
TTisSDF_attribute_suffix_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTisSDF_attribute_suffix);
}

static BOOL
TTisSDF_attribute_sepby_t_qcomma(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_plus(t, TTisSDF_attribute);
}

static BOOL
TTist_qcomma(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, ",");
}

BOOL
TTisSDF_attr_seplist(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunSDF_attr_seplist;
}

BOOL
TTisSDF_attribute(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunSDF_attribute;
}

BOOL
TTisSDF_attribute_suffix(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunSDF_attribute_suffix;
}

BOOL
TTisSDF_attribute_word(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunSDF_attribute_word;
}

BOOL
TTisSDF_attributes(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunSDF_attributes;
}

BOOL
TTisSDF_basic_symbol(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunSDF_basic_symbol;
}

BOOL
TTisSDF_combined_symbol(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunSDF_combined_symbol;
}

BOOL
TTisSDF_context_free_priorities(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunSDF_context_free_priorities;
}

BOOL
TTisSDF_context_free_restrictions(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunSDF_context_free_restrictions;
}

BOOL
TTisSDF_context_free_syntax(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunSDF_context_free_syntax;
}

BOOL
TTisSDF_context_free_variables(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunSDF_context_free_variables;
}

BOOL
TTisSDF_exports_section(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunSDF_exports_section;
}

BOOL
TTisSDF_grammar_section(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunSDF_grammar_section;
}

BOOL
TTisSDF_hiddens_section(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunSDF_hiddens_section;
}

BOOL
TTisSDF_imports_section(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunSDF_imports_section;
}

BOOL
TTisSDF_lexical_restrictions(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunSDF_lexical_restrictions;
}

BOOL
TTisSDF_lexical_syntax(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunSDF_lexical_syntax;
}

BOOL
TTisSDF_lexical_variables(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunSDF_lexical_variables;
}

BOOL
TTisSDF_module(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunSDF_module;
}

BOOL
TTisSDF_module_name(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunSDF_module_name;
}

BOOL
TTisSDF_priorities(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunSDF_priorities;
}

BOOL
TTisSDF_priority(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunSDF_priority;
}

BOOL
TTisSDF_production(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunSDF_production;
}

BOOL
TTisSDF_repetition(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunSDF_repetition;
}

BOOL
TTisSDF_restriction(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunSDF_restriction;
}

BOOL
TTisSDF_sdf(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunSDF_sdf;
}

BOOL
TTisSDF_section(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunSDF_section;
}

BOOL
TTisSDF_sort(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunSDF_sort;
}

BOOL
TTisSDF_sorts_section(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunSDF_sorts_section;
}

BOOL
TTisSDF_symbol(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunSDF_symbol;
}

BOOL
TTisSDF_symbol_group(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunSDF_symbol_group;
}

BOOL
TTisSDF_symbol_permutation(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunSDF_symbol_permutation;
}

BOOL
TTisSDF_symbol_sep_plus(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunSDF_symbol_sep_plus;
}

BOOL
TTisSDF_symbol_sep_star(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunSDF_symbol_sep_star;
}

BOOL
TTisSDF_terminal(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunSDF_terminal;
}

BOOL
TTisSDF_char_class(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunSDF_char_class;
}

BOOL
TTisSDF_ident(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunSDF_ident;
}

BOOL
TTisSDF_literal(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunSDF_literal;
}

TTterm
TTbuildSDF_attr_seplist(TTterm t1)
{
    assert(TTisSDF_attribute_sepby_t_qcomma(t1));
    args[0] = t1;
    return TTbuild_term(TTfunSDF_attr_seplist, args);
}

TTterm
TTbuildSDF_attribute(TTterm t1, TTterm t2)
{
    assert(TTisSDF_attribute_word(t1) && TTisSDF_attribute_suffix_opt(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunSDF_attribute, args);
}

TTterm
TTbuildSDF_attribute_suffix(TTterm t1, TTterm t2, TTterm t3)
{
    assert(TTist_qpopen(t1) && TTisSDF_literal(t2) && TTist_qpclose(t3));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    return TTbuild_term(TTfunSDF_attribute_suffix, args);
}

TTterm
TTbuildSDF_attribute_word(TTterm t1)
{
    assert(TTisSDF_ident(t1));
    args[0] = t1;
    return TTbuild_term(TTfunSDF_attribute_word, args);
}

TTterm
TTbuildSDF_attributes(TTterm t1, TTterm t2, TTterm t3)
{
    assert(TTist_qcbopen(t1) && TTisSDF_attr_seplist_opt(t2) && TTist_qcbclose(t3));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    return TTbuild_term(TTfunSDF_attributes, args);
}

TTterm
TTbuildSDF_basic_symbol(TTterm t1)
{
    assert(TTisSDF_sort(t1) || TTisSDF_terminal(t1) || TTisSDF_char_class(t1) || TTisSDF_symbol_group(t1) || TTisSDF_symbol_sep_plus(t1) || TTisSDF_symbol_sep_star(t1) || TTisSDF_symbol_permutation(t1));
    args[0] = t1;
    return TTbuild_term(TTfunSDF_basic_symbol, args);
}

TTterm
TTbuildSDF_combined_symbol(TTterm t1, TTterm t2)
{
    assert(TTisSDF_basic_symbol(t1) && TTisSDF_repetition_opt(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunSDF_combined_symbol, args);
}

TTterm
TTbuildSDF_context_free_priorities(TTterm t1, TTterm t2, TTterm t3)
{
    assert(TTist_context_free(t1) && TTist_priorities(t2) && TTisSDF_priorities_opt(t3));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    return TTbuild_term(TTfunSDF_context_free_priorities, args);
}

TTterm
TTbuildSDF_context_free_restrictions(TTterm t1, TTterm t2, TTterm t3)
{
    assert(TTist_context_free(t1) && TTist_restrictions(t2) && TTisSDF_restriction_star(t3));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    return TTbuild_term(TTfunSDF_context_free_restrictions, args);
}

TTterm
TTbuildSDF_context_free_syntax(TTterm t1, TTterm t2, TTterm t3)
{
    assert(TTist_context_free(t1) && TTist_syntax(t2) && TTisSDF_production_star(t3));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    return TTbuild_term(TTfunSDF_context_free_syntax, args);
}

TTterm
TTbuildSDF_context_free_variables(TTterm t1, TTterm t2)
{
    assert(TTist_variables(t1) && TTisSDF_production_star(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunSDF_context_free_variables, args);
}

TTterm
TTbuildSDF_exports_section(TTterm t1, TTterm t2)
{
    assert(TTist_exports(t1) && TTisSDF_grammar_section_star(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunSDF_exports_section, args);
}

TTterm
TTbuildSDF_grammar_section(TTterm t1)
{
    assert(TTisSDF_lexical_syntax(t1) || TTisSDF_lexical_variables(t1) || TTisSDF_lexical_restrictions(t1) || TTisSDF_context_free_syntax(t1) || TTisSDF_context_free_variables(t1) || TTisSDF_context_free_restrictions(t1) || TTisSDF_context_free_priorities(t1) || TTisSDF_sorts_section(t1));
    args[0] = t1;
    return TTbuild_term(TTfunSDF_grammar_section, args);
}

TTterm
TTbuildSDF_hiddens_section(TTterm t1, TTterm t2)
{
    assert(TTist_hiddens(t1) && TTisSDF_grammar_section_star(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunSDF_hiddens_section, args);
}

TTterm
TTbuildSDF_imports_section(TTterm t1, TTterm t2)
{
    assert(TTist_imports(t1) && TTisSDF_module_name_star(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunSDF_imports_section, args);
}

TTterm
TTbuildSDF_lexical_restrictions(TTterm t1, TTterm t2, TTterm t3)
{
    assert(TTist_lexical(t1) && TTist_restrictions(t2) && TTisSDF_restriction_star(t3));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    return TTbuild_term(TTfunSDF_lexical_restrictions, args);
}

TTterm
TTbuildSDF_lexical_syntax(TTterm t1, TTterm t2, TTterm t3)
{
    assert(TTist_lexical(t1) && TTist_syntax(t2) && TTisSDF_production_star(t3));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    return TTbuild_term(TTfunSDF_lexical_syntax, args);
}

TTterm
TTbuildSDF_lexical_variables(TTterm t1, TTterm t2, TTterm t3)
{
    assert(TTist_lexical(t1) && TTist_variables(t2) && TTisSDF_production_star(t3));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    return TTbuild_term(TTfunSDF_lexical_variables, args);
}

TTterm
TTbuildSDF_module(TTterm t1, TTterm t2, TTterm t3, TTterm t4)
{
    assert(TTist_module(t1) && TTisSDF_module_name(t2) && TTisSDF_imports_section_star(t3) && TTisSDF_section_star(t4));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    args[3] = t4;
    return TTbuild_term(TTfunSDF_module, args);
}

TTterm
TTbuildSDF_module_name(TTterm t1)
{
    assert(TTisSDF_ident(t1));
    args[0] = t1;
    return TTbuild_term(TTfunSDF_module_name, args);
}

TTterm
TTbuildSDF_priorities(TTterm t1)
{
    assert(TTisSDF_priority_sepby_t_qcomma(t1));
    args[0] = t1;
    return TTbuild_term(TTfunSDF_priorities, args);
}

TTterm
TTbuildSDF_priority(TTterm t1)
{
    assert(TTisSDF_production_sepby_t_qgt(t1));
    args[0] = t1;
    return TTbuild_term(TTfunSDF_priority, args);
}

TTterm
TTbuildSDF_production(TTterm t1, TTterm t2, TTterm t3, TTterm t4)
{
    assert(TTisSDF_symbol_star(t1) && TTist___qgt(t2) && TTisSDF_symbol(t3) && TTisSDF_attributes_opt(t4));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    args[3] = t4;
    return TTbuild_term(TTfunSDF_production, args);
}

TTterm
TTbuildSDF_repetition(TTterm t1)
{
    assert(TTist_qquestion(t1) || TTist_qplus(t1) || TTist_qmultiply(t1));
    args[0] = t1;
    return TTbuild_term(TTfunSDF_repetition, args);
}

TTterm
TTbuildSDF_restriction(TTterm t1, TTterm t2, TTterm t3)
{
    assert(TTisSDF_symbol_star(t1) && TTist___qdivide_(t2) && TTisSDF_char_class_star(t3));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    return TTbuild_term(TTfunSDF_restriction, args);
}

TTterm
TTbuildSDF_sdf(TTterm t1, TTterm t2)
{
    assert(TTist_definition(t1) && TTisSDF_module_star(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunSDF_sdf, args);
}

TTterm
TTbuildSDF_section(TTterm t1)
{
    assert(TTisSDF_exports_section(t1) || TTisSDF_hiddens_section(t1));
    args[0] = t1;
    return TTbuild_term(TTfunSDF_section, args);
}

TTterm
TTbuildSDF_sort(TTterm t1)
{
    assert(TTisSDF_ident(t1));
    args[0] = t1;
    return TTbuild_term(TTfunSDF_sort, args);
}

TTterm
TTbuildSDF_sorts_section(TTterm t1, TTterm t2)
{
    assert(TTist_sorts(t1) && TTisSDF_symbol_star(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunSDF_sorts_section, args);
}

TTterm
TTbuildSDF_symbol(TTterm t1)
{
    assert(TTisSDF_combined_symbol_sepby_t_qpipe(t1));
    args[0] = t1;
    return TTbuild_term(TTfunSDF_symbol, args);
}

TTterm
TTbuildSDF_symbol_group(TTterm t1, TTterm t2, TTterm t3)
{
    assert(TTist_qpopen(t1) && TTisSDF_symbol_star(t2) && TTist_qpclose(t3));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    return TTbuild_term(TTfunSDF_symbol_group, args);
}

TTterm
TTbuildSDF_symbol_permutation(TTterm t1, TTterm t2, TTterm t3)
{
    assert(TTist_qlt_qlt(t1) && TTisSDF_symbol_star(t2) && TTist_qgt_qgt(t3));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    return TTbuild_term(TTfunSDF_symbol_permutation, args);
}

TTterm
TTbuildSDF_symbol_sep_plus(TTterm t1, TTterm t2, TTterm t3, TTterm t4, TTterm t5)
{
    assert(TTist_qcbopen(t1) && TTisSDF_symbol(t2) && TTisSDF_symbol(t3) && TTist_qcbclose(t4) && TTist_qplus(t5));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    args[3] = t4;
    args[4] = t5;
    return TTbuild_term(TTfunSDF_symbol_sep_plus, args);
}

TTterm
TTbuildSDF_symbol_sep_star(TTterm t1, TTterm t2, TTterm t3, TTterm t4, TTterm t5)
{
    assert(TTist_qcbopen(t1) && TTisSDF_symbol(t2) && TTisSDF_symbol(t3) && TTist_qcbclose(t4) && TTist_qmultiply(t5));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    args[3] = t4;
    args[4] = t5;
    return TTbuild_term(TTfunSDF_symbol_sep_star, args);
}

TTterm
TTbuildSDF_terminal(TTterm t1)
{
    assert(TTisSDF_literal(t1));
    args[0] = t1;
    return TTbuild_term(TTfunSDF_terminal, args);
}

TTterm
TTbuildSDF_char_class(TTtype_string t)
{
    args[0] = (TTterm)t;
    return TTbuild_term(TTfunSDF_char_class, args);
}

TTterm
TTbuildSDF_ident(TTtype_string t)
{
    args[0] = (TTterm)t;
    return TTbuild_term(TTfunSDF_ident, args);
}

TTterm
TTbuildSDF_literal(TTtype_string t)
{
    args[0] = (TTterm)t;
    return TTbuild_term(TTfunSDF_literal, args);
}

BOOL
TTmatchSDF_attr_seplist(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunSDF_attr_seplist)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchSDF_attribute(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunSDF_attribute)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchSDF_attribute_suffix(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3)
{
    if (t->fun == TTfunSDF_attribute_suffix)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchSDF_attribute_word(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunSDF_attribute_word)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchSDF_attributes(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3)
{
    if (t->fun == TTfunSDF_attributes)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchSDF_basic_symbol(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunSDF_basic_symbol)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchSDF_combined_symbol(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunSDF_combined_symbol)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchSDF_context_free_priorities(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3)
{
    if (t->fun == TTfunSDF_context_free_priorities)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchSDF_context_free_restrictions(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3)
{
    if (t->fun == TTfunSDF_context_free_restrictions)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchSDF_context_free_syntax(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3)
{
    if (t->fun == TTfunSDF_context_free_syntax)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchSDF_context_free_variables(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunSDF_context_free_variables)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchSDF_exports_section(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunSDF_exports_section)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchSDF_grammar_section(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunSDF_grammar_section)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchSDF_hiddens_section(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunSDF_hiddens_section)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchSDF_imports_section(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunSDF_imports_section)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchSDF_lexical_restrictions(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3)
{
    if (t->fun == TTfunSDF_lexical_restrictions)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchSDF_lexical_syntax(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3)
{
    if (t->fun == TTfunSDF_lexical_syntax)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchSDF_lexical_variables(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3)
{
    if (t->fun == TTfunSDF_lexical_variables)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchSDF_module(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3, TTterm *t4)
{
    if (t->fun == TTfunSDF_module)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        *t4 = t->u.args[3];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchSDF_module_name(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunSDF_module_name)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchSDF_priorities(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunSDF_priorities)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchSDF_priority(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunSDF_priority)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchSDF_production(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3, TTterm *t4)
{
    if (t->fun == TTfunSDF_production)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        *t4 = t->u.args[3];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchSDF_repetition(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunSDF_repetition)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchSDF_restriction(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3)
{
    if (t->fun == TTfunSDF_restriction)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchSDF_sdf(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunSDF_sdf)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchSDF_section(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunSDF_section)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchSDF_sort(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunSDF_sort)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchSDF_sorts_section(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunSDF_sorts_section)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchSDF_symbol(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunSDF_symbol)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchSDF_symbol_group(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3)
{
    if (t->fun == TTfunSDF_symbol_group)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchSDF_symbol_permutation(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3)
{
    if (t->fun == TTfunSDF_symbol_permutation)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchSDF_symbol_sep_plus(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3, TTterm *t4, TTterm *t5)
{
    if (t->fun == TTfunSDF_symbol_sep_plus)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        *t4 = t->u.args[3];
        *t5 = t->u.args[4];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchSDF_symbol_sep_star(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3, TTterm *t4, TTterm *t5)
{
    if (t->fun == TTfunSDF_symbol_sep_star)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        *t4 = t->u.args[3];
        *t5 = t->u.args[4];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchSDF_terminal(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunSDF_terminal)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchSDF_char_class(TTterm t, TTtype_string *t1)
{
    if (t->fun == TTfunSDF_char_class)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchSDF_ident(TTterm t, TTtype_string *t1)
{
    if (t->fun == TTfunSDF_ident)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchSDF_literal(TTterm t, TTtype_string *t1)
{
    if (t->fun == TTfunSDF_literal)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

