
#include <assert.h>
#include <stdio.h>
#include <unistd.h>
#include "ttfile.h"
#include "tterror.h"

#define BUFSZ 1024

static char st_tmp_buf[BUFSZ];

extern int snprintf(char *s,  size_t  n,  const  char  *format, ...);

FILE * TTfile_open(const char * name, const char * flags)
{
	FILE * f;

	f = fopen(name, flags);
	if (f == 0) {
		snprintf(st_tmp_buf, BUFSZ, "Cannot open file %s.\n", name);
		TTerror(st_tmp_buf);
	}
	return f;
}

int TTfile_exists(const char * name)
{
	return access(name, F_OK) == 0;
}

