
#include <stdlib.h>
#include <assert.h>

#include "gc.h"
#include "ttstack.h"

#define MINIMAL_SIZE 16

TTstack TTstack_alloc(void)
{
	TTstack s;

	s = (TTstack) GC_malloc(sizeof(struct TTstack_struct));
	assert(s != 0);
	s->data = (void **) GC_malloc(MINIMAL_SIZE * sizeof(void *));
	assert(s->data != 0);
	s->size = MINIMAL_SIZE;
	s->top = 0;
	return s;
}

void TTstack_free(TTstack s)
{
	/* Make sure the TTstack is empty before freeing. */
	assert(s->top == 0);
	GC_free(s->data);
	GC_free(s);
}

void TTstack_push(TTstack s, void *x)
{
	if (s->top == s->size) {
		s->size *= 2;
		assert(s->size < 100000);
		s->data =
		    (void **) GC_realloc(s->data, s->size * sizeof(void *));
		assert(s->data != 0);
	}
	s->data[s->top++] = x;
}

void *TTstack_pop(TTstack s)
{
/*	assert(s->top != 0);*/
	return s->data[--s->top];
}

void *	TTstack_top(TTstack s)
{
	assert(s->top != 0);
	return s->data[s->top - 1];
}

