
#include <stdio.h>
#include <malloc.h>
#include <assert.h>
#include "ttterm.h"
#include "ttstrat.h"
#include "ttstratp.h"

/* Shortcuts */
#define succeed TTbuild_succeed
#define fail TTbuild_fail
#define both TTbuild_both
#define choice TTbuild_choice
#define all TTbuild_all
#define one TTbuild_one
#define try TTbuild_try
#define repeat TTbuild_repeat
#define oncebu TTbuild_oncebu
#define oncetd TTbuild_oncetd

TTterm TTbuild_try(TTterm s)
{
	return choice(s, succeed());
}

TTterm TTbuild_repeat(TTterm s)
{
	TTterm this = TTalloc(TTfun_choice);
	this->u.args[0] = both(s, this);
	this->u.args[1] = succeed();
	return TTfinish(this);
}

TTterm TTbuild_totaltd(TTterm s)
{
	TTterm this = TTalloc(TTfun_both);
	this->u.args[0] = s;
	this->u.args[1] = all(this);
	return TTfinish(this);
}

TTterm TTbuild_totalbu(TTterm s)
{
	TTterm this = TTalloc(TTfun_both);
	this->u.args[0] = all(this);
	this->u.args[1] = s;
	return TTfinish(this);
}

TTterm TTbuild_oncetd(TTterm s)
{
	TTterm this = TTalloc(TTfun_choice);
	this->u.args[0] = s;
	this->u.args[1] = one(this);
	return TTfinish(this);
}

TTterm TTbuild_oncebu(TTterm s)
{
	TTterm this = TTalloc(TTfun_choice);
	this->u.args[0] = one(this);
	this->u.args[1] = s;
	return TTfinish(this);
}

TTterm TTbuild_stoptd(TTterm s)
{
	TTterm this = TTalloc(TTfun_choice);
	this->u.args[0] = s;
	this->u.args[1] = all(this);
	return TTfinish(this);
}

TTterm TTbuild_stopbu(TTterm s)
{
	TTterm this = TTalloc(TTfun_choice);
	this->u.args[0] = all(this);
	this->u.args[1] = s;
	return TTfinish(this);
}

TTterm TTbuild_pathtd(TTterm s)
{
	TTterm this = TTalloc(TTfun_both);
	this->u.args[0] = s;
	this->u.args[1] = choice(all(fail()),one(this));
	return TTfinish(this);
}

TTterm TTbuild_naive_innermost(TTterm s)
{
	return repeat(oncebu(s));
}

TTterm TTbuild_innermost(TTterm s)
{
	TTterm this = TTalloc(TTfun_both);
	this->u.args[0] = all(this);
	this->u.args[1] = try(both(s,this));
	return TTfinish(this);
}

TTterm TTbuild_beloweq(TTterm s1, TTterm s2)
{
	return oncetd(both(s2, oncetd(s1)));
}

TTterm TTbuild_untileq(TTterm s1, TTterm s2)
{
	TTterm this = TTalloc(TTfun_both);
	this->u.args[0] = s1;
	this->u.args[1] = choice(s2,one(this));
	return TTfinish(this);
}


