
/* Term library and forward typedefs (for TTbuffer etc.). */

#ifndef	FALSE
#define	FALSE	(0)
#endif

#ifndef	TRUE
#define	TRUE	(!FALSE)
#endif

typedef int BOOL;

typedef struct TTterm_struct * TTterm;
typedef struct TTfun_struct * TTfun;
typedef TTterm (*TTreduce_f)(TTterm);

typedef TTterm TTtype_string;
typedef TTterm TTtype_int;

struct TTfun_struct {
	char * name;
	size_t arity;
	TTfun next;
	int type;
	TTreduce_f reduce;
};

struct TTterm_struct {
	TTfun fun;
	union {
		int val;
		TTterm args[1];
		char str[1];
	} u;
};

TTfun	TTfun_int;
TTfun	TTfun_string;

TTterm   TTbuild_term(TTfun fun, const TTterm * args);

/* For generic traversal support. */
BOOL	TTis_node(TTterm t);
TTterm	TTalloc(TTfun fun);
void	TTfree(TTterm t);
TTterm	TTfinish(TTterm t);

TTfun	TTbuild_fun(const char *name, size_t arity);

BOOL    TTequal(TTterm t1, TTterm t2);
BOOL    TTequal_fun(TTfun f1, TTfun f2);

/* Integer term match/build operations. */
TTterm	TTbuild_int(int n);
BOOL    TTmatch_int(TTterm t, int *x);

/* String term match/build operations. */
TTterm	TTbuild_string(const char * str);
BOOL	TTmatch_string(TTterm t, const char ** x);
TTterm	TTalloc_string(int len);
void	TTfree_string(TTterm t);
TTterm	TTfinish_string(TTterm t);

/* For debugging. */
void    TTdump(TTterm t);

void	TTterm_init( void );

